diff -ruN vdr-1.7.35/dvbspu.h vdr-1.7.36/dvbspu.h
--- vdr-1.7.35/dvbspu.h	2011-03-27 16:50:48.000000000 +0200
+++ vdr-1.7.36/dvbspu.h	2013-01-20 11:15:47.000000000 +0100
@@ -8,13 +8,14 @@
  *
  * parts of this file are derived from the OMS program.
  *
- * $Id: dvbspu.h 2.5 2011/03/27 14:50:48 kls Exp $
+ * $Id: dvbspu.h 2.6 2013/01/20 10:15:47 kls Exp $
  */
 
 #ifndef __DVBSPU_H
 #define __DVBSPU_H
 
 #include <inttypes.h>
+#include "device.h"
 #include "osd.h"
 #include "spu.h"
 #include "thread.h"
@@ -106,7 +107,8 @@
     enum spFlag { spNONE, spHIDE, spSHOW, spMENU };
     spFlag state;
 
-     cSpuDecoder::eScaleMode scaleMode;
+    cSpuDecoder::eScaleMode scaleMode;
+    double xscaling, yscaling;
 
     //highligh area
     bool highlight;
@@ -133,6 +135,7 @@
         return ((spu[0] << 8) | spu[1]);
     };
 
+    void SetSpuScaling(void);
     sDvbSpuRect CalcAreaSize(sDvbSpuRect fgsize, cBitmap *fgbmp, sDvbSpuRect bgsize, cBitmap *bgbmp);
     int CalcAreaBpp(cBitmap *fgbmp, cBitmap *bgbmp);
 
diff -ruN vdr-1.7.35/menu.c vdr-1.7.36/menu.c
--- vdr-1.7.35/menu.c	2012-12-21 12:11:14.000000000 +0100
+++ vdr-1.7.36/menu.c	2013-01-17 15:20:08.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 2.72 2012/12/21 11:11:14 kls Exp $
+ * $Id: menu.c 2.74 2013/01/17 14:20:08 kls Exp $
  */
 
 #include "menu.h"
@@ -2273,7 +2273,6 @@
 {
   const char *CurrentRecording = cReplayControl::LastReplayed();
   cMenuRecordingItem *LastItem = NULL;
-  char *LastItemText = NULL;
   cThreadLock RecordingsLock(&Recordings);
   if (Refresh) {
      if (cMenuRecordingItem *ri = (cMenuRecordingItem *)Get(Current()))
@@ -2285,23 +2284,32 @@
   for (cRecording *recording = Recordings.First(); recording; recording = Recordings.Next(recording)) {
       if (!base || (strstr(recording->Name(), base) == recording->Name() && recording->Name()[strlen(base)] == FOLDERDELIMCHAR)) {
          cMenuRecordingItem *Item = new cMenuRecordingItem(recording, level);
-         if (*Item->Text() && (!Item->IsDirectory() || (!LastItem || !LastItem->IsDirectory() || strcmp(Item->Text(), LastItemText) != 0))) {
+         cMenuRecordingItem *LastDir = NULL;
+         if (Item->IsDirectory()) {
+            // Sorting may ignore non-alphanumeric characters, so we need to explicitly handle directories in case they only differ in such characters:
+            for (cMenuRecordingItem *p = LastItem; p; p = dynamic_cast<cMenuRecordingItem *>(p->Prev())) {
+                if (p->Name() && strcmp(p->Name(), Item->Name()) == 0) {
+                   LastDir = p;
+                   break;
+                   }
+                }
+            }
+         if (*Item->Text() && !LastDir) {
             Add(Item);
             LastItem = Item;
-            free(LastItemText);
-            LastItemText = strdup(LastItem->Text()); // must use a copy because of the counters!
+            if (Item->IsDirectory())
+               LastDir = Item;
             }
          else
             delete Item;
          if (LastItem) {
             if (CurrentRecording && strcmp(CurrentRecording, recording->FileName()) == 0)
                SetCurrent(LastItem);
-            if (LastItem->IsDirectory())
-               LastItem->IncrementCounter(recording->IsNew());
             }
+         if (LastDir)
+            LastDir->IncrementCounter(recording->IsNew());
          }
       }
-  free(LastItemText);
   if (Refresh)
      Display();
 }
@@ -4708,8 +4716,10 @@
     case kPause:
     case kDown:
     case kOk:
-         Seconds = min(Total - STAY_SECONDS_OFF_END, Seconds);
-         Goto(SecondsToFrames(Seconds, FramesPerSecond()), Key == kDown || Key == kPause || Key == kOk);
+         if (timeSearchPos > 0) {
+            Seconds = min(Total - STAY_SECONDS_OFF_END, Seconds);
+            Goto(SecondsToFrames(Seconds, FramesPerSecond()), Key == kDown || Key == kPause || Key == kOk);
+            }
          timeSearchActive = false;
          break;
     default:
diff -ruN vdr-1.7.35/newplugin vdr-1.7.36/newplugin
--- vdr-1.7.35/newplugin	2012-12-28 10:52:29.000000000 +0100
+++ vdr-1.7.36/newplugin	2013-01-12 14:46:00.000000000 +0100
@@ -12,7 +12,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: newplugin 2.15 2012/12/28 09:52:29 kls Exp $
+# $Id: newplugin 2.17 2013/01/12 13:46:00 kls Exp $
 
 $PLUGIN_NAME = $ARGV[0] || die "Usage: newplugin <name>\n";
 
@@ -76,8 +76,8 @@
 
 # Use package data if installed...otherwise assume we're under the VDR source directory:
 PKGCFG = \$(if \$(VDRDIR),\$(shell pkg-config --variable=\$(1) \$(VDRDIR)/vdr.pc),\$(shell pkg-config --variable=\$(1) vdr || pkg-config --variable=\$(1) ../../../vdr.pc))
-LIBDIR = \$(DESTDIR)\$(call PKGCFG,libdir)
-LOCDIR = \$(DESTDIR)\$(call PKGCFG,locdir)
+LIBDIR = \$(call PKGCFG,libdir)
+LOCDIR = \$(call PKGCFG,locdir)
 PLGCFG = \$(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
@@ -121,14 +121,14 @@
 ### Implicit rules:
 
 %.o: %.c
-	\$(CXX) \$(CXXFLAGS) -c \$(DEFINES) \$(INCLUDES) \$<
+	\$(CXX) \$(CXXFLAGS) -c \$(DEFINES) \$(INCLUDES) -o \$\@ \$<
 
 ### Dependencies:
 
 MAKEDEP = \$(CXX) -MM -MG
 DEPFILE = .dependencies
 \$(DEPFILE): Makefile
-	\@\$(MAKEDEP) \$(DEFINES) \$(INCLUDES) \$(OBJS:%.o=%.c) > \$\@
+	\@\$(MAKEDEP) \$(CXXFLAGS) \$(DEFINES) \$(INCLUDES) \$(OBJS:%.o=%.c) > \$\@
 
 -include \$(DEPFILE)
 
@@ -137,7 +137,7 @@
 PODIR     = po
 I18Npo    = \$(wildcard \$(PODIR)/*.po)
 I18Nmo    = \$(addsuffix .mo, \$(foreach file, \$(I18Npo), \$(basename \$(file))))
-I18Nmsgs  = \$(addprefix \$(LOCDIR)/, \$(addsuffix /LC_MESSAGES/vdr-\$(PLUGIN).mo, \$(notdir \$(foreach file, \$(I18Npo), \$(basename \$(file))))))
+I18Nmsgs  = \$(addprefix \$(DESTDIR)\$(LOCDIR)/, \$(addsuffix /LC_MESSAGES/vdr-\$(PLUGIN).mo, \$(notdir \$(foreach file, \$(I18Npo), \$(basename \$(file))))))
 I18Npot   = \$(PODIR)/\$(PLUGIN).pot
 
 %.mo: %.po
@@ -150,7 +150,7 @@
 	msgmerge -U --no-wrap --no-location --backup=none -q -N \$\@ \$<
 	\@touch \$\@
 
-\$(I18Nmsgs): \$(LOCDIR)/%/LC_MESSAGES/vdr-\$(PLUGIN).mo: \$(PODIR)/%.mo
+\$(I18Nmsgs): \$(DESTDIR)\$(LOCDIR)/%/LC_MESSAGES/vdr-\$(PLUGIN).mo: \$(PODIR)/%.mo
 	install -D -m644 \$< \$\@
 
 .PHONY: i18n
@@ -164,7 +164,7 @@
 	\$(CXX) \$(CXXFLAGS) \$(LDFLAGS) -shared \$(OBJS) -o \$\@
 
 install-lib: \$(SOFILE)
-	install -D \$^ \$(LIBDIR)/\$^.\$(APIVERSION)
+	install -D \$^ \$(DESTDIR)\$(LIBDIR)/\$^.\$(APIVERSION)
 
 install: install-lib install-i18n
 
diff -ruN vdr-1.7.35/recording.c vdr-1.7.36/recording.c
--- vdr-1.7.35/recording.c	2012-12-23 16:11:28.000000000 +0100
+++ vdr-1.7.36/recording.c	2013-01-16 15:17:44.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.81 2012/12/23 15:11:28 kls Exp $
+ * $Id: recording.c 2.83 2013/01/16 14:17:44 kls Exp $
  */
 
 #include "recording.h"
@@ -824,10 +824,10 @@
         }
   if (s1 && s2) {
      // To have folders sorted before plain recordings, the '/' s1 points to
-     // is replaced by the character 'b'. All other slashes will be replaced
-     // by 'a' in SortName() (see below), which will result in the desired
+     // is replaced by the character '1'. All other slashes will be replaced
+     // by '0' in SortName() (see below), which will result in the desired
      // sequence:
-     *s1 = 'b';
+     *s1 = '1';
      s1++;
      memmove(s1, s2, t - s2 + 1);
      }
@@ -840,7 +840,7 @@
   if (!*sb) {
      char *s = (RecordingsSortMode == rsmName) ? strdup(FileName() + strlen(VideoDirectory))
                                               : StripEpisodeName(strdup(FileName() + strlen(VideoDirectory)));
-     strreplace(s, '/', 'a'); // some locales ignore '/' when sorting
+     strreplace(s, '/', '0'); // some locales ignore '/' when sorting
      int l = strxfrm(NULL, s, 0) + 1;
      *sb = MALLOC(char, l);
      strxfrm(*sb, s, l);
diff -ruN vdr-1.7.35/remote.c vdr-1.7.36/remote.c
--- vdr-1.7.35/remote.c	2012-01-16 17:57:00.000000000 +0100
+++ vdr-1.7.36/remote.c	2013-01-13 13:01:52.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.c 2.5 2012/01/16 16:57:00 kls Exp $
+ * $Id: remote.c 2.6 2013/01/13 12:01:52 kls Exp $
  */
 
 #include "remote.h"
@@ -356,14 +356,25 @@
 
 void cKbdRemote::Action(void)
 {
+  uint64_t LastCommand = 0;
+  bool Repeat = false;
+
   while (Running()) {
         uint64_t Command = ReadKeySequence();
+        if (LastCommand && Command != LastCommand && Repeat) {
+           if (!rawMode)
+              Put(LastCommand, false, true);
+           Repeat = false;
+           }
         if (Command) {
-           if (rawMode || !Put(Command)) {
+           if (Command == LastCommand)
+              Repeat = true;
+           if (rawMode || !Put(Command, Repeat)) {
               int func = MapCodeToFunc(Command);
               if (func)
                  Put(KBDKEY(func));
               }
            }
+        LastCommand = Command;
         }
 }
diff -ruN vdr-1.7.35/remux.h vdr-1.7.36/remux.h
--- vdr-1.7.35/remux.h	2012-11-19 11:22:28.000000000 +0100
+++ vdr-1.7.36/remux.h	2013-01-20 12:43:59.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.h 2.36 2012/11/19 10:22:28 kls Exp $
+ * $Id: remux.h 2.37 2013/01/20 11:43:59 kls Exp $
  */
 
 #ifndef __REMUX_H
@@ -217,6 +217,8 @@
   int length;
   int pid;
   int index; // points to the next byte to process
+protected:
+  void Reset(void) { index = 0; }
 public:
   cTsPayload(void);
   cTsPayload(uchar *Data, int Length, int Pid = -1);
diff -ruN vdr-1.7.35/svdrp.c vdr-1.7.36/svdrp.c
--- vdr-1.7.35/svdrp.c	2012-12-04 13:08:36.000000000 +0100
+++ vdr-1.7.36/svdrp.c	2013-01-17 16:19:02.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 2.21 2012/12/04 12:08:36 kls Exp $
+ * $Id: svdrp.c 2.23 2013/01/17 15:19:02 kls Exp $
  */
 
 #include "svdrp.h"
@@ -236,9 +236,11 @@
   "    only data for that channel is listed. 'now', 'next', or 'at <time>'\n"
   "    restricts the returned data to present events, following events, or\n"
   "    events at the given time (which must be in time_t form).",
-  "LSTR [ <number> ]\n"
+  "LSTR [ <number> [ path ] ]\n"
   "    List recordings. Without option, all recordings are listed. Otherwise\n"
-  "    the information for the given recording is listed.",
+  "    the information for the given recording is listed. If a recording\n"
+  "    number and the keyword 'path' is given, the actual file name of that\n"
+  "    recording's directory is listed.",
   "LSTT [ <number> ] [ id ]\n"
   "    List timers. Without option, all timers are listed. Otherwise\n"
   "    only the given timer is listed. If the keyword 'id' is given, the\n"
@@ -261,8 +263,7 @@
   "    by the LSTC command.",
   "NEWT <settings>\n"
   "    Create a new timer. Settings must be in the same format as returned\n"
-  "    by the LSTT command. It is an error if a timer with the same channel,\n"
-  "    day, start and stop time already exists.",
+  "    by the LSTT command.",
   "NEXT [ abs | rel ]\n"
   "    Show the next timer event. If no option is given, the output will be\n"
   "    in human readable form. With option 'abs' the absolute time of the next\n"
@@ -1080,16 +1081,44 @@
 
 void cSVDRP::CmdLSTR(const char *Option)
 {
+  int Number = 0;
+  bool Path = false;
   recordings.Update(true);
   if (*Option) {
-     if (isnumber(Option)) {
+     char buf[strlen(Option) + 1];
+     strcpy(buf, Option);
+     const char *delim = " \t";
+     char *strtok_next;
+     char *p = strtok_r(buf, delim, &strtok_next);
+     while (p) {
+           if (!Number) {
+              if (isnumber(p))
+                 Number = strtol(p, NULL, 10);
+              else {
+                 Reply(501, "Error in recording number \"%s\"", Option);
+                 return;
+                 }
+              }
+           else if (strcasecmp(p, "PATH") == 0)
+              Path = true;
+           else {
+              Reply(501, "Unknown option: \"%s\"", p);
+              return;
+              }
+           p = strtok_r(NULL, delim, &strtok_next);
+           }
+     if (Number) {
         cRecording *recording = recordings.Get(strtol(Option, NULL, 10) - 1);
         if (recording) {
            FILE *f = fdopen(file, "w");
            if (f) {
-              recording->Info()->Write(f, "215-");
-              fflush(f);
-              Reply(215, "End of recording information");
+              if (Path)
+                 Reply(250, "%s", recording->FileName());
+              else {
+                 recording->Info()->Write(f, "215-");
+                 fflush(f);
+                 Reply(215, "End of recording information");
+                 }
               // don't 'fclose(f)' here!
               }
            else
@@ -1098,8 +1127,6 @@
         else
            Reply(550, "Recording \"%s\" not found", Option);
         }
-     else
-        Reply(501, "Error in recording number \"%s\"", Option);
      }
   else if (recordings.Count()) {
      cRecording *recording = recordings.First();
@@ -1322,16 +1349,11 @@
   if (*Option) {
      cTimer *timer = new cTimer;
      if (timer->Parse(Option)) {
-        cTimer *t = Timers.GetTimer(timer);
-        if (!t) {
-           Timers.Add(timer);
-           Timers.SetModified();
-           isyslog("timer %s added", *timer->ToDescr());
-           Reply(250, "%d %s", timer->Index() + 1, *timer->ToText());
-           return;
-           }
-        else
-           Reply(550, "Timer already defined: %d %s", t->Index() + 1, *t->ToText());
+        Timers.Add(timer);
+        Timers.SetModified();
+        isyslog("timer %s added", *timer->ToDescr());
+        Reply(250, "%d %s", timer->Index() + 1, *timer->ToText());
+        return;
         }
      else
         Reply(501, "Error in timer settings");
diff -ruN vdr-1.7.35/transfer.c vdr-1.7.36/transfer.c
--- vdr-1.7.35/transfer.c	2012-02-29 15:16:23.000000000 +0100
+++ vdr-1.7.36/transfer.c	2013-01-20 14:40:30.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.c 2.6 2012/02/29 14:16:23 kls Exp $
+ * $Id: transfer.c 2.7 2013/01/20 13:40:30 kls Exp $
  */
 
 #include "transfer.h"
@@ -15,6 +15,7 @@
 :cReceiver(Channel, TRANSFERPRIORITY)
 {
   patPmtGenerator.SetChannel(Channel);
+  retriesExceeded = false;
 }
 
 cTransfer::~cTransfer()
@@ -35,6 +36,10 @@
      cPlayer::Detach();
 }
 
+#define MAXRETRIES     5 // max. number of retries for a single TS packet
+#define RETRYWAIT      5 // time (in ms) between two retries
+#define RETRYPAUSE 10000 // time (in ms) for which to pause retrying once a packet has not been accepted
+
 void cTransfer::Receive(uchar *Data, int Length)
 {
   if (cPlayer::IsAttached()) {
@@ -42,11 +47,18 @@
      // buffering here. The TS packets *must* get through here! However, every
      // now and then there may be conditions where the packet just can't be
      // handled when offered the first time, so that's why we try several times:
-     for (int i = 0; i < 100; i++) {
-         if (PlayTs(Data, Length) > 0)
+     for (int i = 0; i < MAXRETRIES; i++) {
+         if (PlayTs(Data, Length) > 0) {
+            if (retriesExceeded && timer.TimedOut())
+               retriesExceeded = false;
+            return;
+            }
+         if (retriesExceeded) // no retries once a packet has not been accepted
             return;
-         cCondWait::SleepMs(10);
+         cCondWait::SleepMs(RETRYWAIT);
          }
+     retriesExceeded = true;
+     timer.Set(RETRYPAUSE); // wait a while before retrying
      esyslog("ERROR: TS packet not accepted in Transfer Mode");
      }
 }
diff -ruN vdr-1.7.35/transfer.h vdr-1.7.36/transfer.h
--- vdr-1.7.35/transfer.h	2010-01-29 17:38:09.000000000 +0100
+++ vdr-1.7.36/transfer.h	2013-01-20 14:12:38.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.h 2.2 2010/01/29 16:38:09 kls Exp $
+ * $Id: transfer.h 2.3 2013/01/20 13:12:38 kls Exp $
  */
 
 #ifndef __TRANSFER_H
@@ -13,10 +13,13 @@
 #include "player.h"
 #include "receiver.h"
 #include "remux.h"
+#include "tools.h"
 
 class cTransfer : public cReceiver, public cPlayer {
 private:
   cPatPmtGenerator patPmtGenerator;
+  bool retriesExceeded;
+  cTimeMs timer;
 protected:
   virtual void Activate(bool On);
   virtual void Receive(uchar *Data, int Length);
